function [box,newidx] = dorefine3d(box,select,rof)

ord = [-1 -1 -1; 1 -1 -1; 1 1 -1; -1 1 -1; ...
       -1 -1  1; 1 -1  1; 1 1  1; -1 1  1];
N = length(box); N0 = N;
for i = find(select(:)).'
      dx = 0.5*box(i).dimen;

      p = repmat(box(i).midpt,8,1) + 0.5*ord.*repmat(dx,8,1);
      Nchild = 8;
      
      n = size(p,1);
      p = num2cell(p,2);
      [box(N+(1:n)).midpt] = deal(p{:});
      [box(N+(1:n)).dimen] = deal(dx);
      [box(N+(1:n)).child] = deal([]);
      [box(N+(1:n)).depth] = deal(1+box(i).depth);
      [box(N+(1:n)).Nchild] = deal(Nchild);  
      [box(N+(1:n)).parent] = deal(i);
      R = 0.5*sqrt(sum(dx.^2,2));
      [box(N+(1:n)).R] = deal(rof*R); % Radius is rof*R
      [box(N+(1:n)).Rmax] = deal(0);
      [box(N+(1:n)).indlocpts] = deal([]);
      [box(N+(1:n)).Psi] = deal([]);
      [box(N+(1:n)).ep] = deal([]);
      [box(N+(1:n)).nnupdate] = deal(false);
    
      box(i).child = N+(1:n);
      N = N+n;
end
N = length(box);
newidx = (N0+1:N)';